#
#  Coded by Vali
#



from enigma import iServiceInformation
from Components.Converter.Converter import Converter
from Components.Element import cached
from Components.config import config
from Poll import Poll



class vSmartInfo(Poll, Converter, object):
	SMART_LABEL = 0
	SMART_INFO_H = 1
	SMART_INFO_V = 2
	def __init__(self, type):
		Converter.__init__(self, type)
		Poll.__init__(self)
		self.type = {
				"ShowMe": self.SMART_LABEL,
				"ExpertInfo": self.SMART_INFO_H,
				"ExpertInfoVertical": self.SMART_INFO_V
			}[type]
		try:
			self.poll_interval = config.plugins.ValiKSSetup.pollTime.value*1000
		except:
			self.poll_interval = 30000
		self.poll_enabled = True
		self.ar_fec = ["Auto", "1/2", "2/3", "3/4", "5/6", "7/8", "3/5", "4/5", "8/9", "9/10","None","None","None","None","None"]
		self.ar_pol = ["H", "V", "CL", "CR", "na", "na", "na", "na", "na", "na", "na", "na"]
		self.idnames = ("0100,01FF,Seca,S","0500,05FF,Via,V","0600,06FF,Ideto,I","0900,09FF,NDS,Nd","0B00,0BFF,Conax,Co","0D00,0DFF,CryptoW,Cw","1700,17FF,BetaCr,B","1800,18FF,Nagra,N")



	@cached
	
	def getText(self):
		service = self.source.service
		info = service and service.info()
		if not info:
			return ""	
		Ret_Text = ""
		Sec_Text = ""
		if (self.type == self.SMART_INFO_H): # HORIZONTAL
			decID = ""
			decCI = "0x000"
			decFrom = ""
			eMasTime = ""
			res = ""
			dccmd = ""
			searchIDs = []
			foundIDs = []
			xresol = info.getInfo(iServiceInformation.sVideoWidth)
			yresol = info.getInfo(iServiceInformation.sVideoHeight)
			feinfo = (service and service.frontendInfo())
			if (feinfo is not None) and (xresol>0):
				#Ret_Text = str(xresol) + "x" + str(yresol) + "   "
				if (yresol > 580):
					Ret_Text = "HD     "
				else:
					Ret_Text = "SD     "
				frontendData = (feinfo and feinfo.getAll(True))
				if (frontendData is not None):
					if ((frontendData.get("tuner_type") == "DVB-S") or (frontendData.get("tuner_type") == "DVB-C")):
						frequency = (str((frontendData.get("frequency") / 1000)) + " MHz")
						symbolrate = (str((float(frontendData.get("symbol_rate")) / float(1000000))) + " MS/s")
						try:
							if (frontendData.get("tuner_type") == "DVB-S"):
								polarisation_i = frontendData.get("polarization")
							else:
								polarisation_i = 0
							fec_i = frontendData.get("fec_inner")
							Ret_Text = Ret_Text + frequency + "  -  " + self.ar_pol[polarisation_i] + "  -  " + self.ar_fec[fec_i] + "  -  " + symbolrate + "     "
						except:
							Ret_Text = Ret_Text + frequency + "     " + symbolrate + "     "
						orb_pos = ""
						if (frontendData.get("tuner_type") == "DVB-S"):
							orbital_pos = int(frontendData["orbital_position"])
							if orbital_pos > 1800:
								orb_pos = str((float(3600 - orbital_pos))/10.0) + "W"
							elif orbital_pos > 0:
								orb_pos = str((float(orbital_pos))/10.0) + "E"
						Ret_Text = Ret_Text + "Pos: " + orb_pos + "   "
					elif (frontendData.get("tuner_type") == "DVB-T"):
						frequency = (str((frontendData.get("frequency") / 1000)) + " MHz")
						Ret_Text = Ret_Text + "Frequency: " + frequency
				prvd = info.getInfoString(iServiceInformation.sProvider)
				Ret_Text = self.kurz(prvd) + "     " + Ret_Text
			try:
				f = open("/tmp/ecm.info", "r")
				flines = f.readlines()
				f.close()
				for cell in flines:
					if ("caid" in cell)or("CAID" in cell)or("CaID" in cell)or("caID" in cell)or("Caid" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("caid" in cellmembers[x])or("CAID" in cellmembers[x])or("CaID" in cellmembers[x])or("caID" in cellmembers[x])or("Caid" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									if cellmembers[x+1] != "0x000":
										decID = cellmembers[x+1]
										decID = decID.lstrip("0x")
										decID = decID.strip(",;.:-*_<>()[]{}")
										if (len(decID)<4):
											decID = "0" + decID
											decCI = decID
									else:
										decID = ""
				if decID != "":
					for idline in self.idnames:
						IDlist = idline.split(",")
						try:
							if (int(decID,16)>=int(IDlist[0],16)) and (int(decID,16)<=int(IDlist[1],16)):
								decID = IDlist[2] + ":" + decID.upper()
								break
						except:
							pass
				for cell in flines:
					if ("using:" in cell) or ("source:" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("using:" in cellmembers[x]) or ("source:" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									if cellmembers[x+1] != "fta":
										decFrom = cellmembers[x+1]
									else:
										decFrom = ""
				for cell in flines:
					if ("ecm time:" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("time:" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									eMasTime = str(cellmembers[x+1])
								else:
									eMasTime = ""
				for cell in flines:
					if ("address:" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("address:" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									adrFrom = cellmembers[x+1]
									if ("sci0" in adrFrom):
										decFrom = "Slot-1"
									elif ("sci1" in adrFrom):
										decFrom = "Slot-2"
									elif ("sci2" in adrFrom):
										decFrom = "Slot-3"
									else:
										decFrom = adrFrom
				for cell in flines:
					if ("hops:" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("hops:" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									eHops = str(cellmembers[x+1])
								else:
									eHops = ""
				for cell in flines:
					if ("pid:" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("pid:" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									ePid = str(cellmembers[x+1])
									ePid = ePid.lstrip("0x")
									if (len(ePid)==3):
										ePid = "0" + ePid
									elif (len(ePid)==2):
										ePid = "00" + ePid
									elif (len(ePid)==1):
										ePid = "000" + ePid
									ePid = ePid.upper()
								else:
									ePid = ""
				Sec_Text = self.kurz(decFrom) + "     " + decID + "     pid:" + ePid + "     " + eHops + " hops     " + eMasTime + " s"
			except:
				Sec_Text = ""
			try:
				searchIDs =(info.getInfoObject(iServiceInformation.sCAIDs))
				for oneID in searchIDs:
					for idline in self.idnames:
						IDlist = idline.split(",")
						if (oneID>=int(IDlist[0],16)) and (oneID<=int(IDlist[1],16)) and not(oneID==int(decCI,16)):
							if not(IDlist[3] in foundIDs):
								foundIDs.append(IDlist[3]) #+ "(" +hex(oneID).lstrip("0x") + ")")
				res = " ".join(foundIDs)
			except:
				res = ""
			if (info.getInfo(iServiceInformation.sIsCrypted) == 1):
				Ret_Text = Ret_Text + "\n" + self.kurz(res) + "     " + Sec_Text
			else:
				Ret_Text = Ret_Text
			return Ret_Text
		elif (self.type == self.SMART_INFO_V): # VERTIKAL
			decID = ""
			decCI = "0x000"
			decFrom = ""
			eMasTime = ""
			res = ""
			dccmd = ""
			searchIDs = []
			foundIDs = []
			xresol = info.getInfo(iServiceInformation.sVideoWidth)
			yresol = info.getInfo(iServiceInformation.sVideoHeight)
			feinfo = (service and service.frontendInfo())
			if (feinfo is not None) and (xresol>0):
				#Ret_Text = str(xresol) + "x" + str(yresol) + "\n"
				frontendData = (feinfo and feinfo.getAll(True))
				if (frontendData is not None):
					if ((frontendData.get("tuner_type") == "DVB-S") or (frontendData.get("tuner_type") == "DVB-C")):
						frequency = (str((frontendData.get("frequency") / 1000)) + " MHz")
						symbolrate = (str((float(frontendData.get("symbol_rate")) / float(1000000))) + " MS/s")
						try:
							if (frontendData.get("tuner_type") == "DVB-S"):
								polarisation_i = frontendData.get("polarization")
							else:
								polarisation_i = 0
							fec_i = frontendData.get("fec_inner")
							Ret_Text = Ret_Text + frequency + " - " + self.ar_pol[polarisation_i] + "\n" + self.ar_fec[fec_i] + " - " + symbolrate + "\n"
						except:
							Ret_Text = Ret_Text + frequency + "\n" + symbolrate + "\n"
						orb_pos = ""
						if (frontendData.get("tuner_type") == "DVB-S"):
							orbital_pos = int(frontendData["orbital_position"])
							if orbital_pos > 1800:
								orb_pos = str((float(3600 - orbital_pos))/10.0) + "W"
							elif orbital_pos > 0:
								orb_pos = str((float(orbital_pos))/10.0) + "E"
						Ret_Text = Ret_Text + "Pos: " + orb_pos + "\n"
					elif (frontendData.get("tuner_type") == "DVB-T"):
						frequency = (str((frontendData.get("frequency") / 1000)) + " MHz")
						Ret_Text = Ret_Text + "Frequency:\n" + frequency + "\n"
				prvd = info.getInfoString(iServiceInformation.sProvider)
				Ret_Text = self.kurz(prvd) + "\n" + Ret_Text
			try:
				f = open("/tmp/ecm.info", "r")
				flines = f.readlines()
				f.close()
				for cell in flines:
					if ("caid" in cell)or("CAID" in cell)or("CaID" in cell)or("caID" in cell)or("Caid" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("caid" in cellmembers[x])or("CAID" in cellmembers[x])or("CaID" in cellmembers[x])or("caID" in cellmembers[x])or("Caid" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									if cellmembers[x+1] != "0x000":
										decID = cellmembers[x+1]
										decID = decID.lstrip("0x")
										decID = decID.strip(",;.:-*_<>()[]{}")
										if (len(decID)<4):
											decID = "0" + decID
											decCI = decID
									else:
										decID = ""
				if decID != "":
					for idline in self.idnames:
						IDlist = idline.split(",")
						try:
							if (int(decID,16)>=int(IDlist[0],16)) and (int(decID,16)<=int(IDlist[1],16)):
								decID = IDlist[2] + ":" + decID.upper()
								break
						except:
							pass
				for cell in flines:
					if ("using:" in cell) or ("source:" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("using:" in cellmembers[x]) or ("source:" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									if cellmembers[x+1] != "fta":
										decFrom = cellmembers[x+1]
									else:
										decFrom = ""
				for cell in flines:
					if ("ecm time:" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("time:" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									eMasTime = str(cellmembers[x+1])
								else:
									eMasTime = ""
				for cell in flines:
					if ("address:" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("address:" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									adrFrom = cellmembers[x+1]
									if ("sci0" in adrFrom):
										decFrom = "Slot-1"
									elif ("sci1" in adrFrom):
										decFrom = "Slot-2"
									elif ("sci2" in adrFrom):
										decFrom = "Slot-3"
									else:
										decFrom = adrFrom
				for cell in flines:
					if ("hops:" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("hops:" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									eHops = str(cellmembers[x+1])
								else:
									eHops = ""
				for cell in flines:
					if ("pid:" in cell):
						cellmembers = cell.split()
						for x in range(len(cellmembers)):
							if ("pid:" in cellmembers[x]):
								if x<(len(cellmembers)-1):
									ePid = str(cellmembers[x+1])
									ePid = ePid.lstrip("0x")
									if (len(ePid)==3):
										ePid = "0" + ePid
									elif (len(ePid)==2):
										ePid = "00" + ePid
									elif (len(ePid)==1):
										ePid = "000" + ePid
									ePid = ePid.upper()
								else:
									ePid = ""
				Sec_Text = self.kurz(decFrom) + "\n" + decID + "\npid: " + ePid + "\n" + eHops + " hops\n" + eMasTime + " sec." + "\n"
			except:
				Sec_Text = ""
			try:
				searchIDs =(info.getInfoObject(iServiceInformation.sCAIDs))
				for oneID in searchIDs:
					for idline in self.idnames:
						IDlist = idline.split(",")
						if (oneID>=int(IDlist[0],16)) and (oneID<=int(IDlist[1],16)) and not(oneID==int(decCI,16)):
							if not(IDlist[3] in foundIDs):
								foundIDs.append(IDlist[3]) #+ "(" +hex(oneID).lstrip("0x") + ")")
				res = " ".join(foundIDs)
			except:
				res = ""
			if (info.getInfo(iServiceInformation.sIsCrypted) == 1):
				Ret_Text = Ret_Text + "\n" + self.kurz(res) + "\n" + Sec_Text
			else:
				Ret_Text = Ret_Text
			return Ret_Text
		return ""
		

	text = property(getText)

	def changed(self, what):
		Converter.changed(self, what)

	def kurz(self, langTxt):
		if (len(langTxt)>23):
			retT = langTxt[:20]+"..."
			return retT
		else:
			return langTxt










