#######################################################################
#
#    Current Movie-Path Size Renderer for Dreambox-Enigma2
#    Coded by Vali (c)2009
#    Support: www.dreambox-tools.info
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License
#    as published by the Free Software Foundation; either version 2
#    of the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    Usage:
#    <widget render="MovieDirSize" source="global.CurrentTime" font="Regular;20" ..... />
#
#######################################################################



from Components.VariableText import VariableText
from Components.config import config
from enigma import eLabel
from Renderer import Renderer
from os import path, statvfs



class MovieDirSize(Renderer, VariableText):
	def __init__(self):
		Renderer.__init__(self)
		VariableText.__init__(self)
	GUI_WIDGET = eLabel

	def changed(self, what):
		try:
			if path.exists(config.movielist.last_videodir.value):
				stat = statvfs(config.movielist.last_videodir.value)
				free = (stat.f_bavail if stat.f_bavail!=0 else stat.f_bfree) * stat.f_bsize / 1048576
				if free >= 10240:
					fdspace = "%d GB on " %(free/1024)
					self.text = fdspace + _(config.movielist.last_videodir.value)
				else:
					fdspace = "%d MB on " %(free)
					self.text = fdspace + _(config.movielist.last_videodir.value)
			else:
				self.text = '---'
		except:
			self.text = 'ERR'


